<?php
if (!defined( 'ABSPATH')) exit;
function qeapps_dashboard() {
    // Authentication User
    if ( ! current_user_can( 'manage_options' ) ) {
        return;
    }
    // save settings
    $icon_notice = get_option('error_notice_message', false);
    $splash_notice = get_option('splash_error_notice_message', false);
    $qeappspwa_email_notice = get_option('qeappspwa_email_error_message', false);
    $qeappspwa_success_notice = get_option('qeappspwa_email_success_message', false);

    if ($icon_notice)
    {
        delete_option('error_notice_message');
        qeappspwa_display_dynamic_error_notice($icon_notice);
    }
    if ($splash_notice)
    {
        delete_option('splash_error_notice_message');
        qeappspwa_display_dynamic_error_notice($splash_notice);
    }
    if ( isset( $_GET['settings-updated'] ) ) {
        add_settings_error( 'qeapps_pwa_settings_group', 'qeapps_pwa_settings_saved_message', __( 'Settings saved.', 'qeapps-pwa' ), 'updated' );
        settings_errors( 'qeapps_pwa_settings_group' );
    }
    if ($qeappspwa_email_notice)
    {
        delete_option('qeappspwa_email_error_message');
        qeappspwa_display_dynamic_error_notice($qeappspwa_email_notice);
    }
    if ($qeappspwa_success_notice)
    {
        delete_option('qeappspwa_email_success_message');
        qeappspwa_display_dynamic_success_notice($qeappspwa_success_notice);
    }
    ?>
    <style type="text/css">@keyframes fadeEffect {from { opacity: 0; } to { opacity: 1; } } </style>
    <div class="qeapps_row">  
        <h1><?php _e( 'Easy Progressive Web App', 'qeapps-pwa' ); ?> <sup>1.1</sup></h1>
        <form action="<?php echo esc_attr(admin_url('options.php')); ?>" method="post" enctype="multipart/form-data">     
            <?php settings_fields( 'qeapps_pwa_settings_group' ); ?>
            <div class="left-tab-bg-main-floter">
            <div class="qeappspwa-tab">
			  <a id="qeappspwa-default" class="qeappspwa-tablinks" data-href="no" href="#general-settings" onclick="qeappspwaTab(event, '<?php _e( 'settings', 'qeapps-pwa' ); ?>')"><?php _e( 'Settings', 'qeapps-pwa' ); ?></a>
			  <a class="qeappspwa-tablinks" id="qeappspwa-pwahelp" href="#pwahelp-settings" onclick="qeappspwaTab(event, '<?php _e( 'pwahelp', 'qeapps-pwa' ); ?>')" data-href="no"><?php _e( 'Help & Support', 'qeapps-pwa' ); ?></a>
			</div>
			<!-- section settings start-->
			<div id="settings" class="qeappspwa-tabcontent">
                <div class="left-tbl-text-main">
    				<div id="qeappspwa-status-section">
                        
                        <div class="qeappspwa-left">
                            <span class="title-hdng"><?php _e( 'Android Install Count', 'qeapps-pwa' ); ?></span>
                            <div class="block">
                                <div class="num">
                                    <?php
                                        $android_option = get_option('qepwa_android_count', false);
                                        echo (isset($android_option) && $android_option > 0)? esc_attr( $android_option ) : esc_attr(0);
                                    ?>
                                </div>
                            </div>
                        </div>
                        <div class="qeappspwa-right">
                            <span class="title-hdng"><?php _e( 'IOS Install Count', 'qeapps-pwa' ); ?></span>
                            <div class="block">
                                <div class="num premium">Upgrade To Premium</div>
                            </div>
                        </div>
                        

    	                <div class="qeappspwa-left">
    	                	<span class="title-hdng"><?php _e( 'Status', 'qeapps-pwa' ); ?></span>
    	                    <?php do_settings_sections( 'qeapps_pwa_status_section' ); ?>
    	                </div>
    	                <div class="qeappspwa-right">
    	                	<span class="title-hdng"><?php _e( 'Guide', 'qeapps-pwa' ); ?></span>
    	                    <div class="guide-points">
                                <h3><?php _e( 'HOW TO TEST YOUR PWA?','qeapps-pwa' ); ?></h3>
                            <ul>
                                <li><?php _e( 'For Android devices use Google Chrome for best results.','qeapps-pwa' ); ?></li>
                                <li><?php _e( 'For iOS devices use Safari browser for best results.','qeapps-pwa' ); ?></li>
                                <li><?php _e( 'Have another PWA app installed? Please remove the application or disable it temporarily. Having multiple PWA applications enabled can cause unexpected issues with your store.','qeapps-pwa' ); ?></li>
                            </ul>
                            </div>
    	                </div>
    	                
    	            </div>
    	            <div id="qeappspwa-section-two">
    	            	<span class="title-hdng"><?php _e( 'Configurations', 'qeapps-pwa' ); ?></span>
    	                <?php do_settings_sections( 'qeapps_pwa_basic_settings_section' ); ?>
    	            </div>
    	            <div id="qeappspwa-section-three">
    	            	<span class="title-hdng"><?php _e( 'IOS Configurations', 'qeapps-pwa' ); ?></span>
    	                <?php do_settings_sections( 'qeapps_pwa_apple_icon' ); ?>
    	            </div>
    	            <div id="qeappspwa-section-four">
    	            	<span class="title-hdng"><?php _e( 'Advanced Configurations', 'qeapps-pwa' ); ?></span>
    	                <?php do_settings_sections( 'qeapps_pwa_advanced_section' ); ?>
    	            </div>
                    <div class="clearboth"></div>
    	             <?php submit_button( __('Save Settings', 'qeapps-pwa'),"qeapps-submit-class" ); ?>
                     <div class="clearboth"></div>
                </div>
                <div class="right-tbl-text-main">
                    <div class="qeappspwa-phonetab">
                      <a class="qeappspwa-phonetab active" href="javascript:void(0);" onclick="phonetab(event, '<?php _e( 'ios', 'qeapps-pwa' ); ?>')"><?php _e( 'IOS', 'qeapps-pwa' ); ?></a>
                      <a class="qeappspwa-phonetab" href="javascript:void(0);" onclick="phonetab(event, '<?php _e( 'android', 'qeapps-pwa' ); ?>')"><?php _e( 'Android', 'qeapps-pwa' ); ?></a>
                    </div>
                    

                    <div id="ios" class="qeappspwa-phonecontent">
                     <div class="phone-screen-bg">
                        <img src="<?php echo esc_url(QEAPPS_PATH_SRC.'images/ios.png'); ?>" alt="ios">
                      </div>
                    </div>
                    <div id="android" class="qeappspwa-phonecontent" style="display:none">
                      <div class="phone-screen-bg">
                       <img src="<?php echo esc_url(QEAPPS_PATH_SRC.'images/android.png'); ?>" alt="android">
                      </div>
                    </div>
                </div>
			</div>
        </form>
			<!-- section settings end-->
			<!-- section help -->
			<div id="pwahelp" class="qeappspwa-tabcontent">
				<div id="qeappspwa-help" class="qeapppwa-section-tabcontent">
                    <div class="qe-help-and-support-bg-main">
                        <div class="qeappspwa-supports">

                            <span class="title-hdng"><strong><?php esc_html_e( 'Progressive Web App - IOS', 'qeapps-pwa' ); ?></strong></span>
                            <div class="supports-points">
                                <ul class="add-dot-points">
                                    <li><?php esc_html_e( 'Instead of using the App Store, go to the PWA web site in Safari on iOS and tap the “share” button.', 'qeapps-pwa' ); ?></li>
                                    <li><?php esc_html_e( 'Then click the “Add To Home Screen” option.', 'qeapps-pwa' ); ?></li>
                                    <li><?php esc_html_e( 'A popup will ask you to confirm, so just click “Add”.', 'qeapps-pwa' ); ?></li>
                                    <li><?php esc_html_e( 'Now take a look at your home screen, and you’ll see a new icon. Tapping the icon, you’ll see that your PWA opens up in a “frameless” window just like a native App.', 'qeapps-pwa' ); ?></li>
                                </ul>
                            </div>

                            <span class="title-hdng"><strong><?php esc_html_e( 'Progressive Web App - Android', 'qeapps-pwa' ); ?></strong></span>

                            <p class="ad-tops-padding"><?php esc_html_e( 'Adding a PWA to your Android device is very similar to the iOS process. You will need the latest version of the Chrome web browser for this to work!', 'qeapps-pwa' ); ?></p>
                            <div class="supports-points">
                                <ul class="add-dot-points">
                                    <li><?php esc_html_e( 'Go to the PWA website in Chrome, and you will probably see a banner popup (in the example at the bottom of the screen).', 'qeapps-pwa' ); ?></li>
                                    <li><?php esc_html_e( 'If you don’t see the banner, tap the menu button (the three stacked dots in the top right corner).', 'qeapps-pwa' ); ?></li>
                                    <li><?php esc_html_e( 'Either tap the “Add XXXX to Home screen” banner or the “Add To Home Screen” option from the menu, and you’ll see a confirmation popup.', 'qeapps-pwa' ); ?></li>
                                    <li><?php esc_html_e( 'Tap “Add” and wait for a little while…', 'qeapps-pwa' ); ?></li>
                                </ul>
                            </div>                            
                        </div>

                        <?php qeappspwa_support_form(); ?>
                    </div> 
                    
	            </div>
			</div>
            <!-- section help end-->
        
    </div>
    <?php
}
// Register settings
add_action( 'admin_init', 'qeapps_pwa_register_settings' );

function qeapps_pwa_register_settings() {

    // Register Setting
    register_setting( 
        'qeapps_pwa_settings_group',          // Group name
        'qeapps_pwa_manifest_settings',       // Setting
        'qeapps_pwa_validater_and_sanitizer'  // Input sanitizer
    );
    
    // Basic Application Settings
    add_settings_section(
        'qeapps_pwa_basic_settings_section',                  // ID
        __return_false(),                                   // Title
        '__return_false',                                   // Callback Function
        'qeapps_pwa_basic_settings_section'                   // Page slug
    );
    
    // Application Name
    add_settings_field(
        'qeapps_pwa_app_name',                                    // ID
        __('Application Name', 'qeapps-pwa'),                       // Title
        'qeapps_pwa_app_name_callback',                                 // Callback Function
        'qeapps_pwa_basic_settings_section',                      // Page slug
        'qeapps_pwa_basic_settings_section'                       // Settings Section ID
    );
    
    // Application Short Name
    add_settings_field(
        'qeapps_pwa_app_short_name',                              // ID
        __('Application Short Name', 'qeapps-pwa'),                     // Title
        'qeapps_pwa_app_short_name_callback',                           // Callback Function
        'qeapps_pwa_basic_settings_section',                      // Page slug
        'qeapps_pwa_basic_settings_section'                       // Settings Section ID
    );
    
    // Description
    add_settings_field(
        'qeapps_pwa_description',                                 // ID
        __( 'Description', 'qeapps-pwa' ),                          // Title
        'qeapps_pwa_description_callback',                              // Callback Function
        'qeapps_pwa_basic_settings_section',                      // Page slug
        'qeapps_pwa_basic_settings_section'                       // Settings Section ID
    );
    
    // Application Icon
    add_settings_field(
        'qeapps_pwa_icons',                                       // ID
        __('Application Icon', 'qeapps-pwa'),                       // Title
        'qeapps_pwa_app_icon_callback',                                 // Callback function
        'qeapps_pwa_basic_settings_section',                      // Page slug
        'qeapps_pwa_basic_settings_section'                       // Settings Section ID
    );
    
    // Splash Screen Icon
    add_settings_field(
        'qeapps_pwa_splash_icon',                                 // ID
        __('Splash Screen Icon', 'qeapps-pwa'),                     // Title
        'qeapps_pwa_splash_icon_callback',                              // Callback function
        'qeapps_pwa_apple_icon',                      // Page slug
        'qeapps_pwa_apple_icon'                       // Settings Section ID
    );
    
    // Splash Screen Background Color
    add_settings_field(
        'qeapps_pwa_background_color',                            // ID
        __('Background Color', 'qeapps-pwa'),                       // Title
        'qeapps_pwa_background_color_callback',                         // Callback Function
        'qeapps_pwa_basic_settings_section',                      // Page slug
        'qeapps_pwa_basic_settings_section'                       // Settings Section ID
    );
    
    // Theme Color
    add_settings_field(
        'qeapps_pwa_theme_color',                                 // ID
        __('Theme Color', 'qeapps-pwa'),                            // Title
        'qeapps_pwa_theme_color_callback',                              // Callback Function
        'qeapps_pwa_basic_settings_section',                      // Page slug
        'qeapps_pwa_basic_settings_section'                       // Settings Section ID
    );
    
    // Orientation
    add_settings_field(
        'qeapps_pwa_orientation',                                 // ID
        __('Orientation', 'qeapps-pwa'),                            // Title
        'qeapps_pwa_orientation_callback',                              // Callback Function
        'qeapps_pwa_basic_settings_section',                      // Page slug
        'qeapps_pwa_basic_settings_section'                       // Settings Section ID
    );

    // Display
    add_settings_field(
        'qeapps_pwa_display',                                 // ID
        __('Display', 'qeapps-pwa'),                            // Title
        'qeapps_pwa_display_callback',                              // Callback Function
        'qeapps_pwa_basic_settings_section',                      // Page slug
        'qeapps_pwa_basic_settings_section'                       // Settings Section ID
    );
       
      // Ios setting
    add_settings_section(
        'qeapps_pwa_apple_icon',                  // ID
        __return_false(),                                   // Title
        '__return_false',                                   // Callback Function
        'qeapps_pwa_apple_icon'                   // Page slug
    ); 

    // Apple background color
    add_settings_field(
        'qeapps_pwa_apple_background_color',                                 // ID
        __('Background Color', 'qeapps-pwa'),                            // Title
        'qeapps_pwa_apple_background_color_callback',                              // Callback Function
        'qeapps_pwa_apple_icon',                      // Page slug
        'qeapps_pwa_apple_icon'                       // Settings Section ID
    ); 

    // Status
    add_settings_section(
        'qeapps_pwa_status_section',                  // ID
        __return_false(),                        // Title
        '__return_false',                               // Callback Function
        'qeapps_pwa_status_section'                   // Page slug
    );

    // HTTPS status
    add_settings_field(
        'qeapps_pwa_https_status',                                // ID
        __('HTTPS', 'qeapps-pwa'),                                // Title
        'qeapps_pwa_https_status_callback',                             // Callback Function
        'qeapps_pwa_status_section',                          // Page slug
        'qeapps_pwa_status_section'                           // Settings Section ID
    ); 
    // Manifest status
    add_settings_field(
        'qeapps_pwa_manifest_status',                             // ID
        __('Manifest', 'qeapps-pwa'),                               // Title
        'qeapps_pwa_manifest_status_callback',                          // Callback Function
        'qeapps_pwa_status_section',                          // Page slug
        'qeapps_pwa_status_section'                           // Settings Section ID
    );
    // Service Worker status
    add_settings_field(
        'qeapps_pwa_sw_status',                                   // ID
        __('Service Worker', 'qeapps-pwa'),                         // Title
        'qeapps_pwa_sw_status_callback',                                // Callback Function
        'qeapps_pwa_status_section',                          // Page slug
        'qeapps_pwa_status_section'                           // Settings Section ID
    ); 

    // advanced section
    add_settings_section(
    	'qeapps_pwa_advanced_section',                  // ID
        __return_false(),                        // Title
        '__return_false',                               // Callback Function
        'qeapps_pwa_advanced_section'                   // Page slug
    );
   	// Start URL
    add_settings_field(
        'qeapps_pwa_start_url',                                   // ID
        __('Start Page', 'qeapps-pwa'),                             // Title
        'qeapps_pwa_start_url_callback',                                // Callback Function
        'qeapps_pwa_advanced_section',                      // Page slug
        'qeapps_pwa_advanced_section'                       // Settings Section ID
    );
    
    // Offline Page
    /*add_settings_field(
        'qeapps_pwa_offline_page',                                // ID
        __('Offline Page', 'qeapps-pwa'),                           // Title
        'qeapps_pwa_offline_page_callback',                             // Callback Function
        'qeapps_pwa_advanced_section',                      // Page slug
        'qeapps_pwa_advanced_section'                       // Settings Section ID
    );*/

    // Disable home scree
    add_settings_field(
        'qeapps_pwa_disable_add_to_home',                                // ID
        __('Disable "Add to home screen"', 'qeapps-pwa'),                           // Title
        'qeapps_pwa_disable_add_to_home_callback',                             // Callback Function
        'qeapps_pwa_advanced_section',                      // Page slug
        'qeapps_pwa_advanced_section'                       // Settings Section ID
    );

}

// Sanitize Application post data
function qeapps_pwa_validater_and_sanitizer( $settings ) {

    $Arr_pwa_icon = getimagesize($settings['qeapps_pwa_icon']);
    $Arr_pwa_splash_icon = getimagesize($settings['qeapps_pwa_splash_icon']);
    $notice = "";
    $error_show = false;
    if($Arr_pwa_icon['mime']!="image/png"){
        $error_show = true;
        update_option('error_notice_message', "Application Icon Must be PNG.", 'no');
    }
    elseif($Arr_pwa_icon[0]!=192 || $Arr_pwa_icon[1]!=192){
        $error_show = true;
        update_option('error_notice_message', "Application Icon exactly <code>192x192</code> in size.", 'no');
    }
    if($Arr_pwa_splash_icon['mime']!="image/png"){
        $error_show = true;
        update_option('splash_error_notice_message', "Splash Screen Icon Must be PNG.", 'no');
    }
    elseif( $Arr_pwa_splash_icon[0] != 512 || $Arr_pwa_splash_icon[1] != 512 ){
        $error_show = true;
        update_option('splash_error_notice_message', "Splash Screen Icon exactly <code>512x512</code> in size.", 'no');
    }
    if($error_show){
        wp_redirect(wp_sanitize_redirect(admin_url('admin.php?page=easy-progressive-web-app')));exit;
    }
    
    $settings['qeapps_pwa_description'] = sanitize_text_field( $settings['qeapps_pwa_description'] );
    $settings['qeapps_pwa_background_color'] = preg_match( '/#([a-f0-9]{3}){1,2}\b/i', $settings['qeapps_pwa_background_color'] ) ? sanitize_text_field( $settings['qeapps_pwa_background_color'] ) : sanitize_text_field('#1fc628');
    
    $settings['qeapps_pwa_name'] = sanitize_text_field( $settings['qeapps_pwa_name'] ) == '' ? get_bloginfo( 'name' ) : sanitize_text_field( $settings['qeapps_pwa_name'] );
    $settings['qeapps_pwa_short_name'] = substr( sanitize_text_field( $settings['qeapps_pwa_short_name'] ) == '' ? get_bloginfo( 'name' ) : sanitize_text_field( $settings['qeapps_pwa_short_name'] ), 0, 15 );
    $settings['qeapps_pwa_theme_color'] = preg_match( '/#([a-f0-9]{3}){1,2}\b/i', $settings['qeapps_pwa_theme_color'] ) ? sanitize_text_field( $settings['qeapps_pwa_theme_color'] ) : sanitize_text_field('#1fc628');

    //$settings['qeapps_pwa_offline_page'] = sanitize_text_field($settings['qeapps_pwa_offline_page']) > 0 ? sanitize_text_field($settings['qeapps_pwa_offline_page']) : get_option('page_on_front');

    $settings['qeapps_pwa_start_url'] = sanitize_text_field($settings['qeapps_pwa_start_url']) > 0 ? sanitize_text_field($settings['qeapps_pwa_start_url']) : get_option('page_on_front');

    $apple_background_color = preg_match( '/#([a-f0-9]{3}){1,2}\b/i', $settings['qeapps_pwa_apple_background_color'] ) ? sanitize_text_field( $settings['qeapps_pwa_apple_background_color'] ) : sanitize_text_field('#1fc628');

    $settings['qeapps_pwa_splash_icon'] = sanitize_text_field( $settings['qeapps_pwa_splash_icon'] ); 
    $settings['qeapps_pwa_icon'] = sanitize_text_field( $settings['qeapps_pwa_icon'] );

    if( sanitize_text_field( $settings['qeapps_pwa_splash_icon'] ) !=""){
        qeappspwa_splashscreen_uploader($apple_background_color,sanitize_text_field( $settings['qeapps_pwa_splash_icon'] ));
    }
    // Apple Icon
    $settings['apple_background_color'] = $apple_background_color;
    return $settings;
}

/**
 * Application Name
 * CallBack Functions start
 */

function qeapps_pwa_app_name_callback() {

    $settings = qeapps_pwa_get_settings();
    ?>
        <input type="text" name="qeapps_pwa_manifest_settings[qeapps_pwa_name]" class="regular-text" value="<?php if ( isset( $settings['qeapps_pwa_name'] ) && ( ! empty($settings['qeapps_pwa_name']) ) ) echo esc_attr($settings['qeapps_pwa_name']); ?>"/>
        
    <?php
}

/**
 * Application Short Name
 */
function qeapps_pwa_app_short_name_callback() {

    $settings = qeapps_pwa_get_settings(); ?>
        
        <input type="text" name="qeapps_pwa_manifest_settings[qeapps_pwa_short_name]" class="regular-text qe-apps-pwa-short-name" value="<?php if ( isset( $settings['qeapps_pwa_short_name'] ) && ( ! empty($settings['qeapps_pwa_short_name']) ) ) echo esc_attr($settings['qeapps_pwa_short_name']); ?>"/>
        
            <?php printf( __( '<a href="javascript:void(0);" title="Used when there is insufficient space to display the full name of the application." class="tooltip-qe">?</a>', 'qeapps-pwa' ) ); ?>
         
    <?php
}

/**
 * Description
 */
function qeapps_pwa_description_callback() {

    $settings = qeapps_pwa_get_settings(); ?>
        
        <input type="text" name="qeapps_pwa_manifest_settings[qeapps_pwa_description]" class="regular-text" value="<?php if ( isset( $settings['qeapps_pwa_description'] ) && ( ! empty( $settings['qeapps_pwa_description'] ) ) ) echo esc_attr( $settings['qeapps_pwa_description'] ); ?>"/>

        <a href="javascript:void(0);" title="<?php esc_html_e( 'A brief description of what your app is about.', 'qeapps-pwa' ); ?>" class="tooltip-qe"><?php esc_html_e( '?', 'qeapps-pwa' ); ?></a>

    <?php
}

/**
 * Application Icon
 */
function qeapps_pwa_app_icon_callback() {

    $settings = qeapps_pwa_get_settings();
    ?>
    
    <!-- Application Icon -->
    <input type="text" name="qeapps_pwa_manifest_settings[qeapps_pwa_icon]" id="qeapps_pwa_manifest_settings[qeapps_pwa_icon]" class="qeapps-pwa-icon-url regular-text" size="50" value="<?php echo isset( $settings['qeapps_pwa_icon'] ) ? esc_attr( $settings['qeapps_pwa_icon']) : ''; ?>">
    <button type="button" class="button qeapps-pwa-icon-browse" data-editor="content">
        <span class="dashicons dashicons-format-image" style="margin-top: 4px;"></span> <?php esc_html_e( 'Choose Icon', 'qeapps-pwa' ); ?>
    </button>
    <a href="javascript:void(0);" title="<?php esc_html_e( 'This will be the icon of your app when installed on the phone. Must be a PNG image exactly 192x192 in size.', 'qeapps-pwa' ); ?>" class="tooltip-qe"><?php esc_html_e( '?', 'qeapps-pwa' ); ?></a>

    <?php
}

/**
 * Splash Screen Icon
 */
function qeapps_pwa_splash_icon_callback() {

    $settings = qeapps_pwa_get_settings(); ?>
    
    <!-- Splash Screen Icon -->
    <input type="text" name="qeapps_pwa_manifest_settings[qeapps_pwa_splash_icon]" id="qeapps_pwa_manifest_settings[qeapps_pwa_splash_icon]" class="qeapps-pwa-splash-icon-url regular-text" size="50" value="<?php echo isset( $settings['qeapps_pwa_splash_icon'] ) ? esc_attr( $settings['qeapps_pwa_splash_icon']) : ''; ?>">
    <button type="button" class="button qeapps-pwa-splash-icon-browse" data-editor="content">
        <span class="dashicons dashicons-format-image" style="margin-top: 4px;"></span> <?php esc_html_e( 'Choose Icon', 'qeapps-pwa' ); ?>
    </button>
    
    <a href="javascript:void(0);" title="<?php esc_html_e( 'This icon will be displayed on the splash screen of your app on supported devices. Must be a PNG image exactly 512x512 in size.', 'qeapps-pwa' ); ?>" class="tooltip-qe"><?php esc_html_e( '?', 'qeapps-pwa' ); ?></a>

    <?php
}

/**
 * Splash Screen Background Color
 */
function qeapps_pwa_background_color_callback() {

    $settings = qeapps_pwa_get_settings(); ?>
    
    <!-- Background Color -->
    <input type="text" name="qeapps_pwa_manifest_settings[qeapps_pwa_background_color]" id="qeapps_pwa_manifest_settings[qeapps_pwa_background_color]" class="qeapps-pwa-color-picker" value="<?php echo isset( $settings['qeapps_pwa_background_color'] ) ? esc_attr( $settings['qeapps_pwa_background_color']) : esc_attr('#D5E0EB'); ?>" data-default-color="#D5E0EB">
    
    <a href="javascript:void(0);" title="<?php esc_html_e( 'Background color of the splash screen.', 'qeapps-pwa' ); ?>" class="tooltip-qe"><?php esc_html_e( '?', 'qeapps-pwa' ); ?></a>

    <?php
}

/**
 * Theme Color
 */
function qeapps_pwa_theme_color_callback() {

    $settings = qeapps_pwa_get_settings(); ?>
    
    <!-- Theme Color -->
    <input type="text" name="qeapps_pwa_manifest_settings[qeapps_pwa_theme_color]" id="qeapps_pwa_manifest_settings[qeapps_pwa_theme_color]" class="qeapps-pwa-color-picker" value="<?php echo isset( $settings['qeapps_pwa_theme_color'] ) ? esc_attr( $settings['qeapps_pwa_theme_color']) : esc_attr('#D5E0EB'); ?>" data-default-color="#D5E0EB">
    
    <a href="javascript:void(0);" title="<?php esc_html_e( 'Theme color is used on supported devices to tint the UI elements of the browser and app switcher. When in doubt, use the same color as Background Color.', 'qeapps-pwa' ); ?>" class="tooltip-qe"><?php esc_html_e( '?', 'qeapps-pwa' ); ?></a>

    <?php
}

/**
 * Start URL Dropdown
 */
function qeapps_pwa_start_url_callback() {

    $settings = qeapps_pwa_get_settings(); ?>
    
        <!-- WordPress Pages Dropdown -->
        <label for="qeapps_pwa_manifest_settings[qeapps_pwa_start_url]">
        <?php echo wp_dropdown_pages( array( 
                'name' => 'qeapps_pwa_manifest_settings[qeapps_pwa_start_url]', 
                'echo' => 0, 
                'show_option_none' => __( '&mdash; Homepage &mdash;' ), 
                'option_none_value' => '0', 
                'selected' =>  isset($settings['qeapps_pwa_start_url']) ? $settings['qeapps_pwa_start_url'] : '',
            )); ?>
        </label>
        
        
        <?php printf( __( '<a href="javascript:void(0);" title="Specify the page to load when the application is launched from a device. Current start page is %s" class="tooltip-qe">?</a>', 'qeapps-pwa' ), qeapps_pwa_get_start_url() ); ?>
        <?php printf( __( 'Current start page is <code>%s</code>', 'qeapps-pwa' ), qeapps_pwa_get_start_url() ); ?>
        

    <?php
}

/**
 * Offline Page Dropdown
 */

/*function qeapps_pwa_offline_page_callback() {

    $settings = qeapps_pwa_get_settings(); ?>
    
    <!-- WordPress Pages Dropdown -->
    <label for="qeapps_pwa_manifest_settings[qeapps_pwa_offline_page]">
    <?php echo wp_dropdown_pages( array( 
            'name' => 'qeapps_pwa_manifest_settings[qeapps_pwa_offline_page]', 
            'echo' => 0, 
            'show_option_none' => __( '&mdash; Default &mdash;' ), 
            'option_none_value' => '0', 
            'selected' =>  isset($settings['qeapps_pwa_offline_page']) ? $settings['qeapps_pwa_offline_page'] : '',
        )); ?>
    </label>
    
    <p class="description">
        <?php printf( __( 'Offline page is displayed when the device is offline and the requested page is not already cached. Current offline page is <code>%s</code>', 'qeapps-pwa' ), qeapps_pwa_get_offline_page() ); ?>
    </p>

    <?php
}*/

/**
 * Default Orientation Dropdown
 */

function qeapps_pwa_orientation_callback() {

    $settings = qeapps_pwa_get_settings(); ?>
    
    <!-- Orientation Dropdown -->
    <label for="qeapps_pwa_manifest_settings[qeapps_pwa_orientation]">
        <select name="qeapps_pwa_manifest_settings[qeapps_pwa_orientation]" id="qeapps_pwa_manifest_settings[qeapps_pwa_orientation]">
            <option value="<?php echo esc_attr('portrait'); ?>" <?php if ( isset( $settings['qeapps_pwa_orientation'] ) ) { selected( $settings['qeapps_pwa_orientation'], 'portrait' ); } ?>>
                <?php esc_html_e( 'portrait', 'qeapps-pwa' ); ?>
            </option>
            <option value="<?php echo esc_attr('landscape'); ?>" <?php if ( isset( $settings['qeapps_pwa_orientation'] ) ) { selected( $settings['qeapps_pwa_orientation'], 'landscape' ); } ?>>
                <?php esc_html_e( 'landscape', 'qeapps-pwa' ); ?>
            </option>
        </select>
    </label>
    
    <a href="javascript:void(0);" title="<?php esc_html_e( 'Set the orientation of your app on devices. When set to Follow Device Orientation your app will rotate as the device is rotated.', 'qeapps-pwa' ); ?>" class="tooltip-qe"><?php esc_html_e( '?', 'qeapps-pwa' ); ?></a>

    <?php
}

/**
 * Default Display Dropdown
 */
function qeapps_pwa_display_callback() {

    $settings = qeapps_pwa_get_settings(); ?>
    
    <!-- Display Dropdown -->
    <label for="qeapps_pwa_manifest_settings[qeapps_pwa_display]">
        <select name="qeapps_pwa_manifest_settings[qeapps_pwa_display]" id="qeapps_pwa_manifest_settings[qeapps_pwa_display]">
            <option value="<?php esc_html_e('fullscreen'); ?>" <?php if ( isset( $settings['qeapps_pwa_display'] ) ) { selected( $settings['qeapps_pwa_display'], 'fullscreen' ); } ?>>
                <?php esc_html_e( 'Full Screen', 'qeapps-pwa' ); ?>
            </option>
            <option value="<?php esc_html_e('standalone'); ?>" <?php if ( isset( $settings['qeapps_pwa_display'] ) ) { selected( $settings['qeapps_pwa_display'], 'standalone' ); } ?>>
                <?php esc_html_e( 'Standalone', 'qeapps-pwa' ); ?>
            </option>
            <option value="<?php esc_html_e('minimal-ui'); ?>" <?php if ( isset( $settings['qeapps_pwa_display'] ) ) { selected( $settings['qeapps_pwa_display'], 'minimal-ui' ); } ?>>
                <?php esc_html_e( 'Minimal UI', 'qeapps-pwa' ); ?>
            </option>
        </select>
    </label>
    
    <a href="javascript:void(0);" title="<?php esc_html_e( 'Display mode decides what browser UI is shown when your app is launched. Standalone is default.', 'qeapps-pwa' ); ?>" class="tooltip-qe"><?php esc_html_e( '?', 'qeapps-pwa' ); ?></a>

    <?php
}
/**
 * Theme Apple Background Color
 */
function qeapps_pwa_apple_background_color_callback() {

    $settings = qeapps_pwa_get_settings(); 
    ?>
    
    <!-- Theme Color -->
    <input type="text" name="qeapps_pwa_manifest_settings[qeapps_pwa_apple_background_color]" id="qeapps_pwa_manifest_settings[qeapps_pwa_apple_background_color]" class="qeapps-pwa-color-picker" value="<?php echo isset( $settings['qeapps_pwa_apple_background_color'] ) ? esc_attr( $settings['qeapps_pwa_apple_background_color']) : esc_attr('#D5E0EB'); ?>" data-default-color="#D5E0EB">

    <a href="javascript:void(0);" title="<?php esc_html_e('Centralize Image with Background Color.', 'qeapps-pwa'); ?>" class="tooltip-qe"><?php esc_html_e( '?', 'qeapps-pwa' ); ?></a>

    <?php
}

/**
 * HTTP Status
 */
function qeapps_pwa_https_status_callback() {

    if ( is_ssl() ) {
        
        printf( '<p><span class="dashicons dashicons-yes" style="color: #46b450;"></span> ' . __( 'Your website is served over HTTPS.', 'qeapps-pwa' ) . '</p>' );
    } else {
        
        printf( '<p><span class="dashicons dashicons-no-alt" style="color: #dc3232;"></span> ' . __( 'Progressive Web Apps require that your website is served over HTTPS. Please contact your host to add a SSL certificate to your domain.', 'qeapps-pwa' ) . '</p>' );
    }
}

/**
 * Service Worker Status
 */
function qeapps_pwa_sw_status_callback() {
    
    if ( qeapps_pwa_file_exists( home_url( '/' ) .qeapps_pwa_get_filename('service_worker') ) ) {
        
         printf( '<p><span class="dashicons dashicons-yes" style="color: #46b450;"></span> ' . __( 'Service worker generated successfully.', 'qeapps-pwa' ) . '</p>' );

    } else {
        

        printf( '<p><span class="dashicons dashicons-no-alt" style="color: #dc3232;"></span> ' . __( 'Service worker generation failed.', 'qeapps-pwa' ) . '</p>');
        
    }
    
}

/**
 * Manifest Status
 */
function qeapps_pwa_manifest_status_callback() {
    
    if ( qeapps_pwa_file_exists( home_url( '/' ) .qeapps_pwa_get_filename('manifest') ) ) {
        
        printf( '<p><span class="dashicons dashicons-yes" style="color: #46b450;"></span> ' . __( 'Manifest generated successfully.', 'qeapps-pwa' ) . '</p>' );

    } else {
        
        printf( '<p><span class="dashicons dashicons-no-alt" style="color: #dc3232;"></span> ' . __( 'Manifest generation failed. ', 'qeapps-pwa' ) . '</p>');

    }
}

function qeapps_pwa_disable_add_to_home_callback() {
	// Get Settings
	$settings = qeapps_pwa_get_settings(); 
	?><input type="checkbox" name="qeapps_pwa_manifest_settings[qeapps_pwa_disable_add_to_home]" id="qeapps_pwa_manifest_settings[qeapps_pwa_disable_add_to_home]" value="<?php echo esc_attr('1'); ?>" 
	<?php if ( isset( $settings['qeapps_pwa_disable_add_to_home'] ) ) { checked( '1', $settings['qeapps_pwa_disable_add_to_home'] ); } ?>>
	<label for="qeapps_pwa_manifest_settings[qeapps_pwa_disable_add_to_home]"><?php _e('Remove default banner', 'qeapps-pwa') ?></label>
	<br>
	<?php
}